#define __ARRAY_H

#ifndef __STDLIB_H
#  include <stdlib.h>
#endif


#ifndef __STRING_H
#  include <string.h>
#endif


/*
	Defines the class of rubber arrays. Ignores constructors and
	destructors, if there are any

*/



template <class T>
 class ARRAY
  {
   private:
    T* array;
    int size;
    int quant;
    T init_val;
    inline void Expand(int);

   public:
    ARRAY(int q,T& iv) :
     array(0),
     size(0),
     quant(q),
     init_val(iv)
     {};
    ARRAY(T& iv) :
     array(0),
     size(0),
     quant(32),
     init_val(iv)
     {};
    ARRAY(T iv) :
     array(0),
     size(0),
     quant(32),
     init_val(iv)
     {};
    inline ~ARRAY();
    inline T& operator[](int i);
    inline T& Sub(int i) // unsafe! 
     {
      return array[i];
     };
    inline int Size() { return size; };
  };

template <class T>
 void ARRAY<T>::Expand(int i)
  {
   int newsize = size;

   // increasing the size to accommodate i
   do { newsize += quant; }
   while (i >= newsize);

   // allocating new array
   T* newarray = (T*)(new char[sizeof(T)*newsize]);
   // copy the old array as just memory
   memcpy(newarray,array,sizeof(T)*size);
   for (int i = size; i < newsize; i++)
    {
     newarray[i] = init_val;
    };

   // deleting the old array
   if (array) { delete [] (char*)array; };

   // changing the array and the size
   array = newarray;
   size = newsize;
  };

template <class T>
 inline ARRAY<T>::~ARRAY()
  {
   if (array) { delete [] (char*)array; };
  };


template <class T>
 inline T& ARRAY<T>::operator[](int i)
  {
   if (i >= size)  // index more than the allocated size
    { Expand(i); };
   return array[i];
  };
  
//************************************************************************