#include "back_demodulation.h"

//****************************************************************************************



void BACK_DEMOD::IntegrateIntoIndex(Clause* cl)
 {
  TERM* lits = cl->Literals(); 
  int num_of_max_lits = lits->MaxLiterals();
  TERM* lit;
  TERM::ITERATOR iter;     
  for (int ln = 0; ln < num_of_max_lits; ln++)
   {
    lit = lits->NthArg(ln)->First();
    if (lit->IsEquality() && lit->IsOrderedEq())
     {
      iter.Reset(lit->Args()->First());
     }
    else
     {
      iter.Reset(lit);
      iter.Next();
     };
    do
     {
      TERM* t = iter.CurrPos();
      if (t->IsComplex())
       {
        CLAUSES* cls = (CLAUSES*)(t->Info()->First());
        if (!cls) { cls = new CLAUSES(); t->Info()->SetFirst((TERM*)cls); };
        cls->Insert(cl,ln);         
       };
     }
    while (iter.Next());      
   };
 }; // void BACK_DEMOD::IntegrateIntoIndex(Clause* cl) 

void BACK_DEMOD::RemoveFromIndex(Clause* cl)
 {
   
  TERM* lits = cl->Literals(); 
  int num_of_max_lits = lits->MaxLiterals();
  TERM* lit;
  TERM::ITERATOR iter;     
  for (int ln = 0; ln < num_of_max_lits; ln++)
   {
    lit = lits->NthArg(ln)->First();
    if (lit->IsEquality() && lit->IsOrderedEq())
     {
      iter.Reset(lit->Args()->First());
     }
    else
     {
      iter.Reset(lit);
      iter.Next();
     };
    do
     {
      TERM* t = iter.CurrPos();
      if (t->IsComplex())
       {
        CLAUSES* cls = (CLAUSES*)(t->Info()->First());
        if (cls)
	 {

	   // cout << cls->NumberOfElements() << "\n"; // debug

        
          cls->Remove(cl);
          if (!cls->NumberOfElements()) { delete cls; t->Info()->SetFirst((TERM*)0); };  
         };
       };
     }
    while (iter.Next()); 
   };
 }; // void BACK_DEMOD::RemoveFromIndex(Clause* cl) 









//****************************************************************************************
