#include <stdlib.h>
#include <signal.h>
//#include "signal.h"


#include "vampire.h"
#include "debug.h"

#ifdef _DEBUG_

ofstream dout;

const char* debug_control_point = "uncknown control point";

void DebugWarning(const char* msg)
 {
  Output("DEBUG WARNING: ");
  Output(msg);
  Output("\n");
 };

void InitDebugHandlers();

void InitDebug()
 {
  dout.open("vampire.dout",ios::out);
  InitDebugHandlers();
 }; 

void DebugError(const char* msg)
 {
  Output("Debug error: ");
  Output(msg);
  Output('\n');
  Output("Control point: ");
  Output(debug_control_point);
  Output('\n');
  exit(EXIT_SUCCESS);
 };  // DebugError()

void DebugError(const char* msg1,const char* msg2,const char* msg3)
 {
  Output("Debug error: ");
  Output(msg1);
  Output(msg2);
  Output(msg3);
  Output('\n');
  Output("Control point: ");
  Output(debug_control_point);
  Output('\n');
  exit(EXIT_SUCCESS);
 };  // DebugError()

void DEBUG_CONTROL_POINT(const char* const p)
 {
  debug_control_point = p;
 }; // void DEBUG_CONTROL_POINT(const char* const p)

void REPORT_CONTROL_POINT()
 {
  Output(debug_control_point);
 };

void DebugSIGSEGVHandler(int)
 {
  Output("DEBUG: Segmentation violation in ");
  Output(debug_control_point);
  Output("\n");
  exit(EXIT_SUCCESS);
 };

void DebugSIGBUSHandler(int)
 {
  Output("DEBUG: Bus error in ");
  Output(debug_control_point);
  Output("\n");
  exit(EXIT_SUCCESS);
 };

void InitDebugHandlers()
 {
  signal(SIGSEGV,DebugSIGSEGVHandler);
  signal(SIGBUS,DebugSIGBUSHandler);
 };

#endif


void RuntimeError(const char* msg)
 {
  Output("Runtime error: ");
  Output(msg);
  Output('\n');
  CloseOutput();
  exit(EXIT_SUCCESS);
 }  // RuntimeError()


void RuntimeError(const char* msg1,const char* msg2,const char* msg3)
 {
  Output("Runtime error: ");
  Output(msg1);
  Output(msg2);
  Output(msg3);
  Output('\n');
  CloseOutput();
  exit(EXIT_SUCCESS);
 }  // RuntimeError()


//***********************************************************************

