#define __FIFO_H
#ifndef __DEBUG_H
 #include "debug.h"
#endif
#ifndef __MEMORY_H
 #include "memory.h"
#endif
//************************************************************

template <class C>
 class FIFO
  {
   private:
    class LIST
     {
      private:
       C first;
       LIST* next;
      public:
       LIST(const C& hd,LIST* tl) : first(hd), next(tl) {};
       inline C& Hd() { return first; };
       inline LIST*& Tl() { return next; }; 
       inline void* operator new(size_t)
        {
         return Memory::Allocate(sizeof(LIST)/4);
        };
       inline void operator delete(void* obj)
        {
         Memory::Deallocate(obj,sizeof(LIST)/4);
        };
     }; // class LIST
   private:
    LIST* first;
    LIST* last;
   public:  
    FIFO() : first((LIST*)0), last((LIST*)0) {};
    inline void Enqueue(const C& el)
     {
      if (last)
       {
        last->Tl() = new LIST(el,(LIST*)0);
        last = last->Tl();
       }
      else // empty queue
       {
        last = new LIST(el,(LIST*)0);
        first = last;
       };
     };
    inline bool Dequeue(C& el)
     {
      if (first)
       {
        LIST* tmp = first;
        el = first->Hd();
        if (last == first)
         {
          first = (LIST*)0;
          last = (LIST*)0;
         }
        else first = first->Tl();
         delete tmp;
        return true;
       }
      else return false; // empty 
     };
  }; // class FIFO


//************************************************************
