#include "forward_subsumption.h"

//********************* Definitions for FS: *****************************************

//#define DO(s) { if (call_num == 492) { s; }; };
#define DO(s) { };

Clause* FS::Subsume()
 { 
  //static long call_num = 0; // debug
  //call_num++;
  //cout << call_num << "\n"; // debug
  
  
  DCONTROL7("BEGIN in FS::Subsume()");
  FS_COMMAND* curr_instr = Tree();
  if (!(curr_instr)) return (Clause*)0; 
  
  EndOfQuery();
  
  DCONTROL7("A0 in FS::Subsume()");
  
  const FLAT_TERM* cursor;
  
  TERM curr_sym;
  LIT* curr_lit;
  LIT* next_lit;
   // stacks
  LIT* backtrack_lit[MAX_NUMBER_OF_LITERALS];
  LIT** next_backtrack_lit = backtrack_lit;
  FS_COMMAND* backtrack_instr[MAX_FS_CODE_DEPTH];
  FS_COMMAND** next_backtrack_instr = backtrack_instr;
  
  const FLAT_TERM* backtrack_cursor[MAX_FS_CODE_DEPTH];
  const FLAT_TERM** next_backtrack_cursor = backtrack_cursor;
  
  Clause* subsuming_cl;
  
  check_tag:
  
   //DO(
     //cout << "FORWARD\n";
     //curr_instr->Output(subst); // debug
     //cout << "\n";
   //);
     
   switch (curr_instr->Tag())
    {
     case FS_COMMAND::LIT_HEADER : 
      curr_lit = FirstLit(curr_instr->HeaderNum());
      if (curr_lit)
       {
        next_lit = curr_lit->Next(); 
        if (next_lit || curr_instr->Fork())
         {
          *next_backtrack_lit = next_lit;
          next_backtrack_lit++;
          *next_backtrack_instr = curr_instr;
          next_backtrack_instr++;
         }; 
        cursor = curr_lit->Args();
        curr_instr = curr_instr->Next();
        goto check_tag;
       }
      else // no literal with this header
       goto try_fork;
     
     case FS_COMMAND::ORD_EQ : 
     
      curr_lit = FirstLit(curr_instr->HeaderNum());
      if (curr_lit)
       {
        next_lit = curr_lit->Next(); 
        if (next_lit || curr_instr->Fork())
         {
          *next_backtrack_lit = next_lit;
          next_backtrack_lit++;
          *next_backtrack_instr = curr_instr;
          next_backtrack_instr++;
         };
        cursor = curr_lit->Arg1();
        curr_instr = curr_instr->Next();
        goto check_tag;
       }
      else // no ordered equations with this polarity
       goto try_fork;
       
       
     case FS_COMMAND::UNORD_EQ : 
      curr_lit = FirstLit(curr_instr->HeaderNum());
      if (curr_lit)
       {
        *next_backtrack_lit = curr_lit; 
        next_backtrack_lit++;
        
        curr_instr->SwapOn();
        
        *next_backtrack_instr = curr_instr;
        next_backtrack_instr++;
        
        cursor = curr_lit->Arg1();
        
        curr_instr = curr_instr->Next();
        
        goto check_tag;
       }
      else // no equations with this polarity (neither ordered nor unordered)
       goto try_fork; 
       
     case FS_COMMAND::PROP_LIT :
      if (FirstLit(curr_instr->HeaderNum())) // the query contains such literal
       {
        if (curr_instr->Fork()) 
         {
          *next_backtrack_instr = curr_instr;
          next_backtrack_instr++;
         }; 
        curr_instr = curr_instr->Next(); 
        goto check_tag;
       }
      else // no such literal in the query, try fork
       goto try_fork; 
       
       
     case FS_COMMAND::SECOND_EQ_ARG :
     
      if (cursor->IsBackJump()) 
       {
        //cout << "BACK JUMP\n"; // debug
        cursor = cursor->NextTerm();
       }; 
      
      curr_instr = curr_instr->Next(); 
      goto check_tag; 
       
     case FS_COMMAND::FUNC :
      curr_sym = cursor->Symbol();
      if (curr_sym.IsVariable()) goto backtrack;
      
      compare_func:
       if (curr_sym == curr_instr->Func()) 
        {
         cursor++;
         curr_instr = curr_instr->Next();
         goto check_tag; 
        };
       if (curr_sym < curr_instr->Func()) goto backtrack;
       curr_instr = curr_instr->Fork();
       if (!curr_instr) goto backtrack;
       
       func_check_tag:
        if (curr_instr->IsFunc()) goto compare_func;
       
        // here curr_instr must point to a COMPARE instruction without fork
        
        CHECK7(curr_instr->IsCompare(),"E10 in FS::Subsume()");
        CHECK7(!(curr_instr->Fork()),"E11 in FS::Subsume()");
        if ((*(curr_instr->Var1()))->Equal(*(curr_instr->Var2())))
         {
          curr_instr = curr_instr->Next();
          goto func_check_tag;
         }
        else goto backtrack;
        
     case FS_COMMAND::VAR :
      *(curr_instr->Var()) = cursor; 
      
      //cout << "   CURSOR\n         ";
      //cout << (long)cursor << "\n";
      //cursor->OutputTerm(); 
      //cout << "\n";
      
      if ((curr_instr->Fork()) && (cursor->Symbol().IsNotVariable()))
       {
        *next_backtrack_instr = curr_instr;
        next_backtrack_instr++;
        *next_backtrack_cursor = cursor;
        next_backtrack_cursor++;
       };
       
      cursor = cursor->NextTerm();
      curr_instr = curr_instr->Next();
      goto check_tag;
      
     case FS_COMMAND::COMPARE : 
     
      DO(
         (*(curr_instr->Var1()))->OutputTerm(); cout << " <?> ";
         (*(curr_instr->Var2()))->OutputTerm(); cout << "\n"; 
        );
     
     
      if ((*(curr_instr->Var1()))->Equal(*(curr_instr->Var2())))
       {
        if (curr_instr->Fork()) 
         {
          *next_backtrack_instr = curr_instr;
          next_backtrack_instr++;
          *next_backtrack_cursor = cursor;
          next_backtrack_cursor++;
         };
        curr_instr = curr_instr->Next(); 
        goto check_tag; 
       }
      else goto try_fork;
     
     case FS_COMMAND::SUCCESS : 
      DCONTROL7("SUCCESS in FS::Subsume()");
      subsuming_cl = curr_instr->TheClause();
      if (FS_QUERY::SubsumptionAllowed(subsuming_cl)) return subsuming_cl;
      goto backtrack; 
      
     #ifdef _DEBUG7_  
      default: DebugError("Illegal FS-instruction in FS::Subsume()"); return (Clause*)0; 
     #else
      #ifdef _SUPPRESS_WARNINGS_
       default: return (Clause*)0; 
      #endif
     #endif  
    }; 
   
  try_fork:
   curr_instr = curr_instr->Fork();
   if (curr_instr) goto check_tag;
  
   // no fork, try to backtrack
  backtrack: 
   if (next_backtrack_instr == backtrack_instr) 
    {
    
     DO(
        OutputCode();
        
        RuntimeError("") 
         
       ); // debug
    
     DCONTROL7("FAILURE in FS::Subsume()");
     return (Clause*)0;
    }; 
   
   next_backtrack_instr--;
   curr_instr = *next_backtrack_instr;
   
   DO(
   cout << "BACKTRACK\n";
   curr_instr->Output(subst); // debug
   cout << "\n";
   );
   
   switch (curr_instr->Tag())
    {
     case FS_COMMAND::LIT_HEADER :
      next_backtrack_lit--;
      curr_lit = *next_backtrack_lit;
      if (!curr_lit) goto try_fork;
      next_lit = curr_lit->Next(); 
      if (next_lit || curr_instr->Fork())
       {
        *next_backtrack_lit = next_lit;
        next_backtrack_lit++;
        *next_backtrack_instr = curr_instr;
        next_backtrack_instr++;
       }; 
      cursor = curr_lit->Args();
      curr_instr = curr_instr->Next();
      goto check_tag;
     
     case FS_COMMAND::ORD_EQ :
      next_backtrack_lit--;
      curr_lit = *next_backtrack_lit;
      
      if (!curr_lit) goto try_fork;
      
      next_lit = curr_lit->Next(); 
      if (next_lit || curr_instr->Fork())
       {
        *next_backtrack_lit = next_lit;
        next_backtrack_lit++;
        *next_backtrack_instr = curr_instr;
        next_backtrack_instr++;
       }; 
      cursor = curr_lit->Arg1();
      curr_instr = curr_instr->Next();
      goto check_tag;
      
     case FS_COMMAND::UNORD_EQ :
      next_backtrack_lit--;
      curr_lit = *next_backtrack_lit;
      if (!curr_lit) goto try_fork;
      
      if (curr_instr->SwapFlag()) 
       {
        //cout << "SWAP\n"; // debug
        
        next_lit = curr_lit->Next();
        if (next_lit || curr_instr->Fork())
         {
          *next_backtrack_lit = next_lit;
          next_backtrack_lit++;
          curr_instr->SwapOff();
          *next_backtrack_instr = curr_instr;
          next_backtrack_instr++;
         };
         
        //curr_lit->Arg1()->OutputTerm(); cout << " ---- "; // debug  
        //curr_lit->Arg2()->OutputTerm(); cout << "\n"; // debug  
         
        cursor = curr_lit->Arg2();
       }
      else
       {
        //cout << "NO SWAP\n"; // debug
       
        curr_instr->SwapOn();
        next_backtrack_lit++;
        next_backtrack_instr++;
        
        cursor = curr_lit->Arg1();
       }; 
      curr_instr = curr_instr->Next();
      goto check_tag; 
       
     case FS_COMMAND::PROP_LIT :
      curr_instr = curr_instr->Fork();
      goto check_tag; 
     
     case FS_COMMAND::VAR :
      // same as for COMPARE
      
     case FS_COMMAND::COMPARE :
      curr_instr = curr_instr->Fork();
      next_backtrack_cursor--;
      cursor = *next_backtrack_cursor;
      goto check_tag;
    
     #ifdef _DEBUG7_  
      default: DebugError("Illegal backtrack in FS::Subsume()"); return (Clause*)0; 
     #else
      #ifdef _SUPPRESS_WARNINGS_
       default: return (Clause*)0; 
      #endif
     #endif 
    };
 }; // Clause* FS::Subsume()




//***********************************************************************************