// temporary experimental module

#ifndef __TERM_H
 #include "term.h"
#endif

#ifndef __ARRAY_H
 #include "array.h"
#endif

//*******************************************************************************
 
class HEADER_SET
 {
  private:
   ARRAY<bool> positive;
   ARRAY<bool> negative;
   STACK<TERM,MAX_NUMBER_OF_LITERALS*2> registered;
  public:
   HEADER_SET() 
    : positive(false),
      negative(false),
      registered("MAX_NUMBER_OF_LITERALS*2 in HEADER_SET::registered")
    {};
   inline void Reset()
    {
     while (!(registered.Empty()))
      {
       Unregister(registered.Pop());
      };
    };
   
   inline bool& Registered(const TERM header) 
    {
     if (header.Polarity() == POL_POS)
      {
       return positive[header.Functor()];
      }
     else
      {
       return negative[header.Functor()];
      };
    };
   
   inline void Register(const TERM header) 
    {
     if (!(Registered(header)))
      {
       Registered(header) = true;
       registered.Push(header);
      };     
    };
   inline void Unregister(const TERM header) 
    {
     Registered(header) = false;
    };
 }; // class HEADER_SET
 
//*******************************************************************************
 
  
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 