#include "hyperresolution.h"


HYPERRESOLUTION HyperResolution;

//************* Definitions for HYPERRESOLUTION: ****************************

void HYPERRESOLUTION::ProcessRule()
 {
  DCONTROL1("A1 in HYPERRESOLUTION::ProcessRule()");
     
  if (CurrentRule()->LongLHS()) 
   {
       
    DCONTROL1("A2 in HYPERRESOLUTION::ProcessRule()");
       
    DCONTROL1("A3 in HYPERRESOLUTION::ProcessRule()");
       
    long_lhs:
       
     DCONTROL1("A4 in HYPERRESOLUTION::ProcessRule()");
       
     if (FindLeaves())
      {
          
       DCONTROL1("A5 in HYPERRESOLUTION::ProcessRule()");   
          
       ProcessLeaves();
          
       DCONTROL1("A6 in HYPERRESOLUTION::ProcessRule()");
          
       while (ChangeLeaves())
        {
           
         DCONTROL1("A7 in HYPERRESOLUTION::ProcessRule()");
           
         ProcessLeaves();
            
         DCONTROL1("A8 in HYPERRESOLUTION::ProcessRule()");
        };
          
       DCONTROL1("A9 in HYPERRESOLUTION::ProcessRule()");
           
      };
         
     DCONTROL1("A10 in HYPERRESOLUTION::ProcessRule()");
         
     if (CurrentRule()->NextApplication())
      {
          
       DCONTROL1("A11 in HYPERRESOLUTION::ProcessRule()");
          
       goto long_lhs;
      };
        
    DCONTROL1("A12 in HYPERRESOLUTION::ProcessRule()");  
       
   }
  else // rule with 1 lhs literal
   {
    short_lhs:
       
     DCONTROL1("A13 in HYPERRESOLUTION::ProcessRule()");
       
     ProcessCandidates();
        
     DCONTROL1("A14 in HYPERRESOLUTION::ProcessRule()");
        
     if (CurrentRule()->NextApplication())
      {

       DCONTROL1("A15 in HYPERRESOLUTION::ProcessRule()");
          
       goto short_lhs;
      };
        
     DCONTROL1("A16 in HYPERRESOLUTION::ProcessRule()"); 
   };
     
  DCONTROL1("END in HYPERRESOLUTION::ProcessRule()");
     
 }; // void HYPERRESOLUTION::ProcessRule()





bool HYPERRESOLUTION::FindLeaves()
 {
 
  DCONTROL1("A1 HYPERRESOLUTION::FindLeaves()"); 
  
  HYPER_ACTIVE_RULE::ResetIterOverLHS();
  
  DCONTROL1("A1.1 HYPERRESOLUTION::FindLeaves()"); 
  
  
  //CurrentRule()->Output(); cout << "\n\n"; // debug
  
  bool wasUsed;
  PREFIX_SYM* lhs_lit = CurrentRule()->NextLHSLiteral(wasUsed);
  
  DCONTROL1("A2 HYPERRESOLUTION::FindLeaves()");  
    
  int unloaded;
  if (cascade.LoadLHSLiteral(lhs_lit,wasUsed))
   {
    
    DCONTROL1("A3 HYPERRESOLUTION::FindLeaves()");    
    
    try_next_lhs_literal:
    
     DCONTROL1("A4 HYPERRESOLUTION::FindLeaves()");
    
     if ((lhs_lit = CurrentRule()->NextLHSLiteral(wasUsed)))
      {
        
       DCONTROL1("A5 HYPERRESOLUTION::FindLeaves()"); 
      
       if (cascade.LoadLHSLiteral(lhs_lit,wasUsed))
        {
         DCONTROL1("A6 HYPERRESOLUTION::FindLeaves()");
        
         goto try_next_lhs_literal;
        }
       else // try to backtrack
        {
        
         DCONTROL1("A7 HYPERRESOLUTION::FindLeaves()");
        
         HYPER_ACTIVE_RULE::Rollback();
         
         DCONTROL1("A8 HYPERRESOLUTION::FindLeaves()");
         
         if (cascade.Backtrack(unloaded))
          {
          
           DCONTROL1("A9 HYPERRESOLUTION::FindLeaves()");
          
           HYPER_ACTIVE_RULE::Rollback(unloaded);
           
           DCONTROL1("A10 HYPERRESOLUTION::FindLeaves()");
           
           goto try_next_lhs_literal;
          }
         else // no resolvents
          {
           
           DCONTROL1("A11 HYPERRESOLUTION::FindLeaves()");
          
           HYPER_ACTIVE_RULE::Rollback(unloaded);
           
           DCONTROL1("A12 HYPERRESOLUTION::FindLeaves()");
           
           return false;
          };
        };
       
       DCONTROL1("A13 HYPERRESOLUTION::FindLeaves()");
        
      }
     else // all lhs literals resolved
      {
       DCONTROL1("A14 HYPERRESOLUTION::FindLeaves()");
       
       return true;
      };
      
    DCONTROL1("A15 HYPERRESOLUTION::FindLeaves()");
      
   }
  else
   {
    
    DCONTROL1("A16 HYPERRESOLUTION::FindLeaves()");
   
    HYPER_ACTIVE_RULE::Rollback();
    
    DCONTROL1("A17 HYPERRESOLUTION::FindLeaves()");
    
    return false; // no resolvents
   };
 }; // bool HYPERRESOLUTION::FindLeaves()

bool HYPERRESOLUTION::ChangeLeaves() 
 {
  DCONTROL1("A1 in HYPERRESOLUTION::ChangeLeaves()"); 
  int unloaded;
  PREFIX_SYM* lhs_lit;
  bool wasUsed;
  backtrack:
   
   DCONTROL1("A2 in HYPERRESOLUTION::ChangeLeaves()"); 
   if (cascade.Backtrack(unloaded))
    {
     DCONTROL1("A3 in HYPERRESOLUTION::ChangeLeaves()");
     HYPER_ACTIVE_RULE::Rollback(unloaded);
     try_next_lhs_literal:
      if ((lhs_lit = CurrentRule()->NextLHSLiteral(wasUsed)))
       {
        if (cascade.LoadLHSLiteral(lhs_lit,wasUsed))
         {
          goto try_next_lhs_literal;
         }
        else
         {
          HYPER_ACTIVE_RULE::Rollback();
          goto backtrack;
         };
       }
      else // all lhs literals resolved
       {
        
        DCONTROL1("B1 in HYPERRESOLUTION::ChangeLeaves()");
        
        return true;
       };
    }
   else // no more leaves
    {
     
     DCONTROL1("B2 in HYPERRESOLUTION::ChangeLeaves()");
     
     HYPER_ACTIVE_RULE::Rollback(unloaded);
     
     DCONTROL1("B3 in HYPERRESOLUTION::ChangeLeaves()");
     return false;
    };
 }; // bool HYPERRESOLUTION::ChangeLeaves()
 
void HYPERRESOLUTION::ProcessLeaves()
 {
  //cout << "HYPERRESOLUTION::ProcessLeaves()\n"; // debug
 
  cascade.LoadFirstCandidates();
  
  //cout << "...........cascade.LoadFirstCandidates();\n"; // debug
  
  do
   {
    //cout << "ProcessCandidates();\n"; // debug
   
    ProcessCandidates();
    
    //cout << "..............ProcessCandidates();\n"; // debug
    
   }
  while (cascade.ChangeCandidates());
  
  //cout << "..............HYPERRESOLUTION::ProcessLeaves()\n"; // debug
 }; // void HYPERRESOLUTION::ProcessLeaves()
 
void HYPERRESOLUTION::CollectAncestors()
 {
  Resolvent.SetBackground(ANCESTORS::RESOL);
  Resolvent.PushAncestor(HYPER_ACTIVE_RULE::FactClause());
  Resolvent.PushAncestor(CurrentRule()->TheClause());
  cascade.CollectAncestors();
 }; // void HYPERRESOLUTION::CollectAncestors() 
 
void HYPERRESOLUTION::ProcessCandidates()
 {
  // first resolvent without factoring

  NewResolvent();
  //if (Resolvent.WasTautology()) { return; };  

  
  // now build all factors
  ResetFactoring();
     
  
  while (NextFactor())
   {

    NewResolvent();
   }; 
 }; // void HYPERRESOLUTION::ProcessCandidates() 

void HYPERRESOLUTION::ResetFactoring()
 {
  CurrentRule()->ResetFactoring();
  cascade.ResetFactoring();
 }; // void HYPERRESOLUTION::ResetFactoring()
 
bool HYPERRESOLUTION::NextFactor()
 {
  if (CurrentRule()->NextFactor()) // factoring the current fact
   {
    return true;
   }
  else
   {
    CurrentRule()->ResetFactoring();   
    return cascade.NextFactor();
   };
 }; // bool HYPERRESOLUTION::NextFactor()


void HYPERRESOLUTION::NewResolvent()
 {
  // TmpClause.Reset();
  Resolvent.Reset();
  
  if (CurrentRule()->CollectLiterals())
   {


    if (cascade.CollectLiterals())
     {


      // resolvent collected 
      
      CollectAncestors();
            
      Resolvent.ProcessCollected();
      
     }
    else
     {
     };
   }
  else
   {
   };
   
 }; // void HYPERRESOLUTION::NewResolvent()







//************************************************************************

