#include "options.h"

void OPTION::DescribeAllOptions()
 {
  // automaticly chosen strategy
  Describe(true,"strat_auto",SWITCH,(void*)1);
  Describe(true,"auto_first_attempt",LONG_INT,(void*)100,"% of max_time"); // per cent of max_time
  
  // inference rules
  Describe(true,"hyper_resolution",SWITCH,(void*)1);
  Describe(true,"static_splitting",SWITCH,(void*)0);
  Describe(true,"dynamic_splitting",SWITCH,(void*)0);
  Describe(true,"paramodulation",SWITCH,(void*)0);
  
  // ordering 
  Describe(true,"positive_is_greater",SWITCH,(void*)0);
  Describe(true,"bin_res_negative_selection",SWITCH,(void*)0);
 
  // preprocessing 
  Describe(true,"prepro_clauses",SWITCH,(void*)1);
  Describe(true,"input_remove_subsumed",SWITCH,(void*)1);
  Describe(true,"prepro_remove_subsumed",SWITCH,(void*)1);
  Describe(true,"prepro_elim_def",SWITCH,(void*)0); 

  // strategy switches
  Describe(true,"forward_subsumption",SWITCH,(void*)1);
  Describe(true,"simplify_by_fs",SWITCH,(void*)0);
  Describe(true,"simplify_forward_by_unit_eq",SWITCH,(void*)0); 
  Describe(true,"simplify_backward_by_unit_eq",SWITCH,(void*)0);
  Describe(true,"simplify_by_eq_res",SWITCH,(void*)0);
  Describe(true,"backward_subsumption",SWITCH,(void*)1);
  Describe(true,"remove_children_of_subsumed",SWITCH,(void*)0);
  Describe(false,"subsume_shorter",SWITCH,(void*)1);
  Describe(true,"set_of_support",SWITCH,(void*)1);
  Describe(false,"hyper_dinamic_lhs_ordering",SWITCH,(void*)1);
  Describe(false,"hyper_unit_conflict",SWITCH,(void*)1);
  Describe(true,"estimate_resources",SWITCH,(void*)0);
  Describe(true,"weight_incrementation",SWITCH,(void*)0);
 
  // numeric options
  Describe(true,"pick_given_ratio",LONG_INT,(void*)0L);
  Describe(true,"max_weight",LONG_INT,(void*)MAXLONG); 
  Describe(true,"max_literal_weight",LONG_INT,(void*)MAXLONG);
  Describe(true,"max_length",LONG_INT,(void*)MAXLONG);
  Describe(true,"max_depth",LONG_INT,(void*)MAXLONG);
 
  Describe(true,"internal_tick_frequency",LONG_INT,(void*)MAXLONG);
  Describe(true,"first_resource_check",LONG_INT,(void*)MAXLONG);
  
  // proof search limits and available resources
  Describe(true,"time_red_mark",LONG_INT,(void*)100,"% of max_time"); // in percents of max_time
  Describe(true,"max_memory",LONG_INT,(void*)MAXLONG,"Kb"); // in Kb
  Describe(true,"memory_red_mark",LONG_INT,(void*)100,"% of max_memory"); // in percents of max_memory
  Describe(false,"max_gen",LONG_INT,(void*)MAXLONG);
  Describe(false,"max_kept",LONG_INT,(void*)MAXLONG);
  Describe(false,"max_used",LONG_INT,(void*)MAXLONG);
  
  // interface options
    // general output options
  Describe(false,"output_to_file",SWITCH,(void*)0);
  Describe(false,"tabulate_to_file",SWITCH,(void*)0);
  Describe(false,"output_file_name",STRING,(void*)("vampire.out"));
  Describe(false,"tabulation_file_name",STRING,(void*)("vampire.tab"));
  Describe(false,"tabulated_file_name_width",LONG_INT,(void*)(16L));
    // options report
  Describe(false,"report_main_options_only",SWITCH,(void*)1);
  Describe(false,"report_options_with_default_values",SWITCH,(void*)0);
    // statistics report
  Describe(false,"statistics_extended_kept_report",SWITCH,(void*)0);
    // progress monitoring
  Describe(false,"show_used",SWITCH,(void*)0);
  Describe(false,"show_kept",SWITCH,(void*)0);
  Describe(false,"show_gen",SWITCH,(void*)0);
  Describe(false,"report_incremented_max_weight",SWITCH,(void*)1);
   // start report
  Describe(false,"start_report_problem_file_name",SWITCH,(void*)1);
  Describe(false,"start_report_version_date",SWITCH,(void*)1);
  Describe(false,"start_report_date",SWITCH,(void*)1);
  Describe(false,"start_report_options",SWITCH,(void*)0);
  Describe(false,"start_report_input_clauses",SWITCH,(void*)0);
  Describe(false,"start_report_preprocessed_clauses",SWITCH,(void*)0);
   // termination report
  Describe(false,"termination_report_problem_file_name",SWITCH,(void*)1);
  Describe(false,"termination_report_proof",SWITCH,(void*)0);
  Describe(false,"termination_report_statistics",SWITCH,(void*)0);
  Describe(false,"termination_report_options",SWITCH,(void*)0);
 }; // void OPTION::DescribeAllOptions()
 
 
 
//****************************************************************************** 
