#include "or_index.h"

//***************** Definitions for OR_INDEX: *****************

void OR_INDEX::Remove(Clause* cl)
 {
   // cout << "REMOVE\n   "; // debug
   // ::Output(cl); cout << "\n"; // debug


  TERM* lit = cl->Literals();
  unsigned num_of_max = lit->MaxLiterals();
  lit = lit->Args();
  for (unsigned lit_num = 0; lit_num < num_of_max; lit_num++)
   {
    DCONTROL15("X10 in OR_INDEX::Remove(Clause* cl)");
    Remove(lit->First(),cl);
    DCONTROL15("X20 in OR_INDEX::Remove(Clause* cl)");
    lit = lit->Next();
   };
 }; // void OR_INDEX::Remove(Clause* c)

void OR_INDEX::RemovePropLit(TERM* lit,Clause* cl)
 {
  CHECK15(!lit->Arity(),"A0 in OR_INDEX::RemovePropLit(..)");
  OR_INDEX_TREE_NODE** tree = Tree(*lit);
  CHECK15(*tree,"A2 in OR_INDEX::RemovePropLit(..)");
  CHECK15((*tree)->IsLeaf(),"A3 in OR_INDEX::RemovePropLit(..)");
  (*tree)->Remove(cl);
  if (!(*tree)->Clauses()) 
   {
    (*tree)->DeleteLeaf();
    *tree = (OR_INDEX_TREE_NODE*)0;
   };
 }; // void OR_INDEX::RemovePropLit(TERM* lit,Clause* cl)
 
/************************* Old buggy version ******************************** 
OR_INDEX_TREE_NODE* OR_INDEX::LeafAndBranch(TERM* t,OR_INDEX_TREE_NODE** tree,OR_INDEX_TREE_NODE**& branch)
 {
  DCONTROL15("BEGIN in OR_INDEX::LeafAndBranch(..)");   
  CHECK15(t->Arity(),"A0 in OR_INDEX::LeafAndBranch(..)");
  branch = tree;
  OR_INDEX_TREE_NODE* node = *branch;
  OR_INDEX_TREE_NODE** below_addr = branch; 
  
  TERM::ITERATOR iter;  

  iter.Reset(t);
  iter.Next();

  DCONTROL15("X10 in OR_INDEX::LeafAndBranch(..)");

  do
   {
    if (node->Alternative())
     {
      DCONTROL15("X20 in OR_INDEX::LeafAndBranch(..)");
      branch = below_addr;
      check_node:
       DCONTROL15("X25 in OR_INDEX::LeafAndBranch(..)");
       if (node->SameSymbol(iter.Symbol()))
        {         
         DCONTROL15("X30 in OR_INDEX::LeafAndBranch(..)");
         below_addr = node->BelowAddr();
         DCONTROL15("X40 in OR_INDEX::LeafAndBranch(..)");
         node = node->Below();
        }
       else // try alternative
        {
         DCONTROL15("X50 in OR_INDEX::LeafAndBranch(..)"); 
         branch = node->AlternativeAddr();
         DCONTROL15("X60 in OR_INDEX::LeafAndBranch(..)"); 
         node = node->Alternative();
         DCONTROL15("X70 in OR_INDEX::LeafAndBranch(..)"); 
         goto check_node;
        };
      DCONTROL15("X80 in OR_INDEX::LeafAndBranch(..)"); 
     }
    else
     {
      DCONTROL15("Y40 in OR_INDEX::LeafAndBranch(..)");

      below_addr = node->BelowAddr();
      DCONTROL15("Y30 in OR_INDEX::LeafAndBranch(..)");
      node = node->Below();
     };
    DCONTROL15("Y20 in OR_INDEX::LeafAndBranch(..)");
   }
  while (iter.Next());
  
  DCONTROL15("Y10 in OR_INDEX::LeafAndBranch(..)");
  CHECK15(node->IsLeaf(),"RES in OR_INDEX::LeafAndBranch(..)");
  return node;
 }; // OR_INDEX_TREE_NODE* OR_INDEX::LeafAndBranch(TERM* t,OR_INDEX_TREE_NODE** tree,OR_INDEX_TREE_NODE**& branch)
 ***************************************************************/

OR_INDEX_TREE_NODE* OR_INDEX::LeafAndBranch(TERM* t,OR_INDEX_TREE_NODE** tree,OR_INDEX_TREE_NODE**& branch)
 {
  DCONTROL15("BEGIN in OR_INDEX::LeafAndBranch(..)");   
  CHECK15(t->Arity(),"A0 in OR_INDEX::LeafAndBranch(..)");
  branch = tree;
  OR_INDEX_TREE_NODE* node = *tree;
  OR_INDEX_TREE_NODE** node_addr = tree; 
  
  TERM::ITERATOR iter;  

  iter.Reset(t);

  DCONTROL15("X10 in OR_INDEX::LeafAndBranch(..)");

  next_sym:
   if (!iter.Next())
    {
     CHECK15(node->IsLeaf(),"RES in OR_INDEX::LeafAndBranch(..)");
     return node;
    };
   check_node:
    if (node->SameSymbol(iter.Symbol()))
     {
      if (node->Alternative()) branch = node_addr;
      node_addr = node->BelowAddr();
      node = node->Below();
      goto next_sym;     
     }; 
    // try alternative
    if (node->Alternative())
     {
      node_addr = node->AlternativeAddr();
      branch = node_addr;
      node = node->Alternative(); 
      goto check_node;
     };
    // no appropriate alternative, search fails
    return (OR_INDEX_TREE_NODE*)0;
 }; // OR_INDEX_TREE_NODE* OR_INDEX::LeafAndBranch(TERM* t,OR_INDEX_TREE_NODE** tree,OR_INDEX_TREE_NODE**& branch)




void OR_INDEX::Remove(TERM* t,Clause* cl,OR_INDEX_TREE_NODE** tree)
 {
  DCONTROL15("BEGIN in OR_INDEX::Remove(TERM* t,Clause* cl,OR_INDEX_TREE_NODE** tree)");
  CHECK15(t->Arity(),"A0 in OR_INDEX::Remove(TERM* t,Clause* cl,OR_INDEX_TREE_NODE** tree)");
  OR_INDEX_TREE_NODE** branch;
  OR_INDEX_TREE_NODE* branch_to_delete;
  OR_INDEX_TREE_NODE* node_to_delete;
  
  DCONTROL15("X10 in OR_INDEX::Remove(TERM* t,Clause* cl,OR_INDEX_TREE_NODE** tree)");
 
  OR_INDEX_TREE_NODE* leaf = LeafAndBranch(t,tree,branch);
  DCONTROL15("X20 in OR_INDEX::Remove(TERM* t,Clause* cl,OR_INDEX_TREE_NODE** tree)");   

  if (!leaf) return;

  leaf->Remove(cl);
  DCONTROL15("X30 in OR_INDEX::Remove(TERM* t,Clause* cl,OR_INDEX_TREE_NODE** tree)");   

  if (!(leaf->Clauses())) 
   {
    // no more clauses in the leaf, the whole branch must be deleted
    // *branch can't be a leaf here
    branch_to_delete = *branch;
    *branch = (*branch)->Alternative(); 
    while (!(branch_to_delete->IsLeaf()))
     {
      node_to_delete = branch_to_delete;
      branch_to_delete = branch_to_delete->Below();
      node_to_delete->DeleteNode();
     };
    branch_to_delete->DeleteLeaf(); // leaf
   };  
  DCONTROL15("END in OR_INDEX::Remove(TERM* t,Clause* cl,OR_INDEX_TREE_NODE** tree)");   
 }; // void OR_INDEX::Remove(TERM* t,Clause* cl,OR_INDEX_TREE_NODE** tree)


void OR_INDEX::RemoveFromBPI(TERM* lit,Clause* cl)
 {
  TERM::ITERATOR iter;
  if (lit->IsEquality() && lit->IsOrderedEq())
   {
    TERM* arg = lit->Args()->First();
    if (!arg->IsVariable())
     {
      iter.Reset(arg);
      do
       {
        if (!iter.CurrentSymIsVar()) RemoveBPRedex(iter.CurrPos(),cl);
       }
      while (iter.Next());
     };
   }
  else // ordinary literal or unordered equality
   {
    iter.Reset(lit);
    while (iter.Next())
     if (!iter.CurrentSymIsVar()) RemoveBPRedex(iter.CurrPos(),cl);
   };
 }; // void OR_INDEX::RemoveFromBPI(TERM* lit,Clause* cl)

void OR_INDEX::RemoveBPRedex(TERM* t,Clause* cl)
 {
  DCONTROL15("BEGIN in OR_INDEX::RemoveBPRedex(TERM* t,Clause* cl)");

  //cout << "REMOVE\n   "; // debug
  //::Output(cl); cout << "\n"; // debug  
  //cout << "   redex "; ::Output(t); cout << "\n"; // debug 

  pseudo_literal->Args()->SetFirst(t);
  DCONTROL15("X10 in OR_INDEX::RemoveBPRedex(TERM* t,Clause* cl)");
  Remove(pseudo_literal,cl,&backward_para_tree);
  DCONTROL15("END in OR_INDEX::RemoveBPRedex(TERM* t,Clause* cl)");
 }; // void OR_INDEX::RemoveBPRedex(TERM* t,Clause* cl)

void OR_INDEX::RemoveFromFPI(TERM* lit,Clause* cl)
 {
  DCONTROL15("BEGIN in OR_INDEX::RemoveFromFPI(TERM* lit,Clause* cl)");
  bool stop = false;
  TERM* arg = lit->Args();
  remove_arg:
   if (arg->IsVariable())
    {
     pseudo_literal[1] = *arg;
     Remove(pseudo_literal,cl,&forward_para_from_var_tree);
    }
   else // complex  
    if (arg->First()->Arity())
     {
      Remove(arg->First(),cl,FParaTree(*(arg->First()))); 
     }
    else // constant 
     {
      DCONTROL15("C100 in OR_INDEX::RemoveFromFPI(TERM* lit,Clause* cl)");
      OR_INDEX_TREE_NODE** tree = FParaTree(*(arg->First()));
      DCONTROL15("C110 in OR_INDEX::RemoveFromFPI(TERM* lit,Clause* cl)");
       
      if (*tree)
       {
        (*tree)->Remove(cl);
        DCONTROL15("C120 in OR_INDEX::RemoveFromFPI(TERM* lit,Clause* cl)"); 
        if (!(*tree)->Clauses()) 
         {
          DCONTROL15("C130 in OR_INDEX::RemoveFromFPI(TERM* lit,Clause* cl)");
          (*tree)->DeleteLeaf();
          DCONTROL15("C140 in OR_INDEX::RemoveFromFPI(TERM* lit,Clause* cl)");
          *tree = (OR_INDEX_TREE_NODE*)0;
         };
        DCONTROL15("C150 in OR_INDEX::RemoveFromFPI(TERM* lit,Clause* cl)");
       };
     };
  if (lit->IsOrderedEq() || stop) 
   { 
    DCONTROL15("END in OR_INDEX::RemoveFromFPI(TERM* lit,Clause* cl)"); 
    return;
   }; 
  stop = true;
  arg = arg->Next();
  goto remove_arg;          
 }; // void OR_INDEX::RemoveFromFPI(TERM* lit,Clause* cl)


void OR_INDEX::Remove(TERM* lit,Clause* cl)
 {
  DCONTROL15("BEGIN in OR_INDEX::Remove(TERM* lit,Clause* cl)"); 
  if (!lit->Arity()) { RemovePropLit(lit,cl); return; };
  DCONTROL15("X10 in OR_INDEX::Remove(TERM* lit,Clause* cl)"); 
  if (paramodulation) RemoveFromBPI(lit,cl);
  DCONTROL15("X20 in OR_INDEX::Remove(TERM* lit,Clause* cl)"); 
  if (lit->IsEquality())
   {     
    DCONTROL15("X30 in OR_INDEX::Remove(TERM* lit,Clause* cl)"); 
    if (lit->Positive()) RemoveFromFPI(lit,cl);
   }
  else 
   {
    DCONTROL15("X40 in OR_INDEX::Remove(TERM* lit,Clause* cl)");  
    Remove(lit,cl,Tree(*lit));
   };
  DCONTROL15("END in OR_INDEX::Remove(TERM* lit,Clause* cl)"); 
 }; // void OR_INDEX::Remove(TERM* lit,Clause* cl)



void OR_INDEX::Destroy()
 {  
  for (int i = 0; i < MAX_NUMBER_OF_FUNCTORS * 2; i++)
   {
    OR_INDEX_TREE_NODE::Destroy(header_index[i]);
    header_index[i] = (OR_INDEX_TREE_NODE*)0;
   }; 
  OR_INDEX_TREE_NODE::Destroy(forward_para_from_var_tree); 
  forward_para_from_var_tree = (OR_INDEX_TREE_NODE*)0;
  OR_INDEX_TREE_NODE::Destroy(backward_para_tree);
  backward_para_tree = (OR_INDEX_TREE_NODE*)0;
 }; // void OR_INDEX::Destroy()

//***************** Definitions for OR_INDEX_TREE_NODE: *****************


void OR_INDEX_TREE_NODE::Destroy(OR_INDEX_TREE_NODE* tree)
 {
  if (!tree) return;
  if (tree->IsLeaf())
   {
    tree->DeleteLeaf();
   }
  else
   {
    OR_INDEX_TREE_NODE* tree_below = tree->Below();
    OR_INDEX_TREE_NODE* tree_alt = tree->Alternative(); 
    tree->DeleteNode();
    Destroy(tree_below);
    if (tree_alt)
     {
      Destroy(tree_alt);
     };   
   };
 }; // void OR_INDEX_TREE_NODE::Destroy(OR_INDEX_TREE_NODE* tree)

//*****************************************************************************
