// Last modified by A.Ryazanov, Apr 13, 1998 :
// now this file is just an interface to separate TPTP parser.

#include "output.h"   //debugging 
#include <iostream.h>   //debugging 


#ifndef __PARSER_H
 #include "parser.h"
#endif

#ifndef _TPTP_TO_VAMPIRE_H
 #include "TPTP_to_Vampire.h"
#endif

#ifndef _TPTP_PARSER_H
 #include "TPTP_Parser/TPTP_parser.h"
#endif

bool ReadFile(const char* TPTPDir, const char* problemName)
 {
  TPTPParsResult *parsRes = new TPTPParsResult; // remember about destruction!
  
  parseTPTP((char *)TPTPDir, (char *)problemName, *parsRes);
  
  if (parsRes->errorFlag)
   { 
    cerr << "\n******** Syntax error in file\n";
    cerr << (parsRes->errorToken)->fileName;
    cerr << ",\nline ";
    cerr << (long unsigned int)((parsRes->errorToken)->lineNum);
    cerr << "\nnear/after ";
    cerr << (parsRes->errorToken)->string;
    cerr << "\n(";
    cerr << parsRes->errorMessage;
    cerr << ")\n";
    return false;
   }
  else 
   {
    processOptions(parsRes->options);
    
    processTPTPProblem(parsRes->problem);

    Signature.MemoLastInputFun();
    delete(parsRes);
    return true; 
   };
 };
 
