#include "premise_factoring.h"

bool OR_PREMISE_WITH_FACTORING::GetFirstFactor(int first_candidate)
 {
  if (FactoringPossible())
   {
    factored.Reset();
    if (FindFirstFactor(first_candidate))
     {
      last_factor = first_candidate;
      was_factored = true;
      return true;
     };
   };
  return false;
 }; // bool OR_PREMISE_WITH_FACTORING::GetFirstFactor(int first_candidate)
 
bool OR_PREMISE_WITH_FACTORING::GetNextFactor()
 {
  int candidate = last_factor + 1;
  next_factor:
   if (FindFirstFactor(candidate))
    {
     factored.Push(last_factor);
     last_factor = candidate;
     return true;
    }
   else // backtrack needed
    {
     GlobalSubst.UnbindLastSection();
     mark[last_factor] = false;
     candidate = last_factor + 1;
     if (factored.Empty())
      {
       if (FindFirstFactor(candidate))
        {
         last_factor = candidate;
         return true;
        }
       else // no more factors at all
        {
         return false;
        };
      }
     else 
      {
       last_factor = factored.Pop();
       goto next_factor;        
      };
    };
 }; // bool OR_PREMISE_WITH_FACTORING::GetNextFactor()
 
extern void OutputPrefix(PREFIX_SYM*); // debug
 
bool OR_PREMISE_WITH_FACTORING::FindFirstFactor(int& candidate)
 {
  while (candidate <= last_max)
   {
    if ((candidate != cut_lit) 
       && (UNIFICATION::UnifyComplex(max_literal[candidate],cut_literal)))   
     {
      // factor found
      mark[candidate] = true;
      return true;
     };
    // continue search
    candidate++;
   };
  // no factor found 
  return false;
 }; // bool OR_PREMISE_WITH_FACTORING::FindFirstFactor(int& candidate)

//**************************************************************************
 