#include "resolvent.h"


//************** Definitions for RESOLVENT: ************************


void RESOLVENT::ProcessCollected() 
 {  
  //cout << "COLLECTED\n"; Output(); cout << "\n"; // debug
  DCONTROL8("BEGIN in RESOLVENT::ProcessCollected()");

  if (clause.Empty()) 
   {
    RegisterNewResolvent(MakeEmptyClause()); 
    return; 
    DCONTROL8("END2 in RESOLVENT::ProcessCollected()"); 
   };
  
  clause.EndOfClause();
 
  if (forward_subsumption) 
   if (FSubsume()) 
    {
     STATISTICS_ON_GENERATED::AnotherForwardSubsumed();
     DCONTROL8("END3 in RESOLVENT::ProcessCollected()");
     return;
    };
 
  DCONTROL8("C10 in RESOLVENT::ProcessCollected()");
  
  // simplify resolvent here
  
  if ((simplification_by_fs) && (SimplifyByFS()))
   {
    STATISTICS_ON_GENERATED::AnotherSimplifiedResolvent();
   };
 
  DCONTROL8("C20 in RESOLVENT::ProcessCollected()");

  simplify:  
   if (simplification_by_ueq)
    {
     DCONTROL8("C20.1 in RESOLVENT::ProcessCollected()");
     if (SimplifyByUEq())
      {
       DCONTROL8("C20.2 in RESOLVENT::ProcessCollected()"); 
       STATISTICS_ON_GENERATED::AnotherSimplifiedResolvent();
       if (!clause.Weed()) return;

       if (clause.Empty()) 
        {
         RegisterNewResolvent(MakeEmptyClause()); 
         return;  
        };
       if (forward_subsumption && FSubsume())
        { 
         STATISTICS_ON_GENERATED::AnotherForwardSubsumed();
         return;
        }; 
     
       DCONTROL8("C30 in RESOLVENT::ProcessCollected()");
       //clause.AllLiterals().Output(); cout << "\n"; // debug      

      };
     DCONTROL8("C20.3 in RESOLVENT::ProcessCollected()");
    }; 
  
  DCONTROL8("C40 in RESOLVENT::ProcessCollected()");
  if (simplification_by_eq_res)
   {
    if (SimplifyByEqRes())
     {
      STATISTICS_ON_GENERATED::AnotherSimplifiedResolvent();
       if (!clause.Weed()) return;

       if (clause.Empty()) 
        {
         RegisterNewResolvent(MakeEmptyClause()); 
         return;  
        };
       if (forward_subsumption && FSubsume())
        { 
         STATISTICS_ON_GENERATED::AnotherForwardSubsumed();
         return;
        }; 

      DCONTROL8("C50 in RESOLVENT::ProcessCollected()");
      goto simplify;
     };  
   };


  if (clause.AllLiterals().Length() == 1)  
   {
    Clause* unit_cl = MakeUnitClause(clause.AllLiterals().Pop());

    RegisterNewResolvent(unit_cl); 

    DCONTROL8("END4 in RESOLVENT::ProcessCollected()");
    return; 
   };   
  
  //cout << "ALL LITERALS\n"; 
  //clause.AllLiterals().Output();
  //cout << "\n";
  
  Clause* cl = MakeSharedClause(clause.AllLiterals());
  
  //cout << "NEW RES\n"; // debug
  //::Output(cl); // debug
  //cout << "\n"; // debug
  
  RegisterNewResolvent(cl);  
  DCONTROL8("END5 in RESOLVENT::ProcessCollected()");
  
 }; // void RESOLVENT::ProcessCollected()  


void RESOLVENT::PreprocessSupported(Clause* cl)
 {
  DCONTROL8("BEGIN in RESOLVENT::PreprocessSupported(..)");
  LoadClause(cl);
  clause.EndOfClause();
  PushAncestor(cl);
  SetBackground(ANCESTORS::PREPRO);
  clause.EndOfClause();
  // apply static splitting here
   
  if ((static_splitting) && (StaticSplitting(true))) return;
   
  // temporary
  DCONTROL8("A20 in RESOLVENT::PreprocessSupported(..)");
  RegisterPreprocessedSupported(MakeUnsharedClause(clause.AllLiterals()));
  DCONTROL8("END in RESOLVENT::PreprocessSupported(..)");
 }; // void RESOLVENT::PreprocessSupported(Clause* cl)

void RESOLVENT::PreprocessUnsupported(Clause* cl)
 {
  LoadClause(cl);
  clause.EndOfClause();
  PushAncestor(cl);
  SetBackground(ANCESTORS::PREPRO);
  RegisterPreprocessedUnsupported(MakeInputClause(ANCESTORS::PREPRO));
 }; // void RESOLVENT::PreprocessUnsupported(Clause* cl)


bool RESOLVENT::SimplifyByEqRes()
 {
  int var;
  const FLAT_TERM* subst_term;
  unsigned subst_depth;
  long subst_weight;
  TMP_LITERAL* simplif_lit;
  TMP_LITERAL** lit = clause.AllLiterals().Last() + 1;   
  try_next_lit:    
   if (lit <= clause.AllLiterals().First()) return false; 
   lit--; 
   simplif_lit = *lit; 
   if (simplif_lit->Negative() && simplif_lit->IsEquality() && simplif_lit->IsUnorderedEq())
    {
     if (simplif_lit->Arg1()->Symbol().IsVariable())
      {
       var = simplif_lit->Arg1()->Symbol().Var();
       if (simplif_lit->Arg2Vars().Occurences(var)) goto try_next_lit;      
       subst_term = simplif_lit->Arg2();
      }
     else 
      if (simplif_lit->Arg2()->Symbol().IsVariable())
       {
        var = simplif_lit->Arg2()->Symbol().Var();
        if (simplif_lit->Arg1Vars().Occurences(var)) goto try_next_lit;
        subst_term = simplif_lit->Arg1();
       }
      else goto try_next_lit;
    
     // ::Output("BEFORE "); clause.AllLiterals().Output(); ::Output("\n");     

     clause.AllLiterals().ReplaceByTop(lit);  
     subst_depth = ((FLAT_TERM*)subst_term)->Depth();
     subst_weight = subst_term->Weight();
     if (clause.AllLiterals().SubstPossible(var,subst_depth,subst_weight))
      {        
       for (TMP_LITERAL** old_lit = clause.AllLiterals().First();old_lit <= clause.AllLiterals().Last();old_lit++)
	{       	
         if ((*old_lit)->Variables().Occurences(var))
	  {
           (*old_lit)->Subst(*(clause.SpareLiteral()),var,(FLAT_TERM*)subst_term);
           TMP_LITERAL* tmp = *old_lit;
           *old_lit = clause.SpareLiteral();
           clause.SpareLiteral() = tmp;
          };    
        };    
       
       // ::Output("AFTER "); clause.AllLiterals().Output(); ::Output("\n\n");
         
       return true; 
      }
     else 
      {
       clause.AllLiterals().Push(simplif_lit);
       goto try_next_lit;
      };
    } 
   else goto try_next_lit;
 }; // bool RESOLVENT::SimplifyByEqRes()


Clause* RESOLVENT::RewriteByUEq(TMP_LITERAL* lit,TMP_LITERAL* new_lit)
 {
  TERM header = lit->Header();
  if (!header.Arity()) return (Clause*)0; // propositional literal
  FLAT_TERM::ITER iter;
  iter.Reset(lit->FlatTerm());
  iter.NextSym(); // skipping the header
  const FLAT_TERM* rewritten_subterm; 
  while (iter.NotEndOfTerm())
   {
    rewritten_subterm = iter.CurrPos();
    if (rewritten_subterm->Symbol().IsComplex())
     {
      if (FSimplificationByUEq.Rewrite(rewritten_subterm))
       {
        new_lit->Reset();
        if (header.IsEquality() && header.IsOrderedEq()) header.MakeUnordered();
        new_lit->PushNonpropHeader(header);        

        iter.Reset(lit->FlatTerm());
        iter.NextSym(); // skipping the header
        TERM sym;
        while (iter.NotEndOfTerm())
	 {
          if (iter.CurrPos() == rewritten_subterm)
	   {
            do
	     {
	      sym = FSimplificationByUEq.RHSSymbol();
              if (sym.IsVariable())
	       {
                new_lit->PushVar(sym);
	       }
              else // functor
	       {
                if (sym.Arity())
		 {
                  if (!new_lit->PushNonconstFun(sym)) goto try_next_position;
                 }
                else // constant
		 {
                  new_lit->PushConst(sym);
                 };
               };
             }
            while (FSimplificationByUEq.RHSNext());
            iter.NextTerm();
	   }
          else
	   {
            sym = iter.CurrPos()->Symbol();
        
            if (sym.IsVariable())
	     {
              new_lit->PushVar(sym);
	     }
            else // functor
             {
              if (sym.Arity())
      	       {
                if (!new_lit->PushNonconstFun(sym)) goto try_next_position;
               }
              else // constant
	       {
                new_lit->PushConst(sym);
               };
             };
        
            iter.NextSym();
           };
         };
        
        //cout << "OLD "; lit->Output(); cout << "\n";
        //cout << "NEW "; new_lit->Output(); cout << "\n";   
        
        Clause* simplifier = FSimplificationByUEq.Rule();       
        PushAncestor(simplifier);
        simplifier->MarkAsSimplifier();
        return simplifier;
       };
     };

    try_next_position:   
     iter.NextSym();
   };
  return (Clause*)0;
 }; // bool RESOLVENT::RewriteByUEq(TMP_LITERAL* lit,TMP_LITERAL* new_lit)




bool RESOLVENT::SimplifyByUEq(TMP_LITERAL*& lit,TMP_LITERAL*& spare_lit)
 {
  DCONTROL8("BEGIN in  RESOLVENT::SimplifyByUEq(TMP_LITERAL*& lit,TMP_LITERAL*& spare_lit)");
  
  //static long call_n = 0; // debug
  //call_n++; // debug
  //cout << call_n << "\n"; // debug

  int num_of_rew = 0;
  Clause* simplifier;
  while ((simplifier = RewriteByUEq(lit,spare_lit))) // assignment, not a comparison 
   {

    CHECK8(((FLAT_TERM*)(spare_lit->FlatTerm()))->CheckIntegrity(),"A10 in RESOLVENT::SimplifyByUEq(TMP_LITERAL*& lit,TMP_LITERAL*& spare_lit)"); 

    TMP_LITERAL* new_spare_lit = lit;
    lit = spare_lit;
    spare_lit = new_spare_lit;
    num_of_rew++;

    //cout << "WAS "; spare_lit->Output(); cout << "\n"; // debug
    //spare_lit->FlatTerm()->OutputStructure(); cout << "\n\n\n"; // debug    
    
    //cout << "NOW "; lit->Output(); cout << "\n"; // debug
    //lit->FlatTerm()->OutputStructure(); cout << "\n\n\n"; // debug    

    // return true; // debug
   };      

  DCONTROL8("END in  RESOLVENT::SimplifyByUEq(TMP_LITERAL*& lit,TMP_LITERAL*& spare_lit)");
  
  return (bool)num_of_rew;
 }; // bool RESOLVENT::SimplifyByUEq(TMP_LITERAL*& lit,TMP_LITERAL*& spare_lit) 

bool RESOLVENT::SimplifyByUEq()
 {  
   //static long call_num = 0; // debug
   //call_num++; // debug
   //cout << call_num << "\n"; // debug

  DCONTROL8("BEGIN in RESOLVENT::SimplifyByUEq()"); 
   //cout << "SIMPLIFY "; clause.AllLiterals().Output(); cout << "\n";

  int num_of_simpl_lits = 0;
  //TMP_LITERAL* spare_lit = clause.SpareTmpLit();
  for (TMP_LITERAL** lit = clause.AllLiterals().First(); lit <= clause.AllLiterals().Last(); lit++) 
   {
     

    if (SimplifyByUEq(*lit,clause.SpareLiteral()))
     {   
      num_of_simpl_lits++;
     }; 
   };

  //clause.AllLiterals().Output(); cout << "\n"; // debug
  //cout << num_of_simpl_lits << "\n"; // debug

  DCONTROL8("END in RESOLVENT::SimplifyByUEq()"); 
  return (bool)num_of_simpl_lits; 
 }; // bool RESOLVENT::SimplifyByUEq()


Clause* RESOLVENT::MakeEmptyClause()
 {
  Clause* empty_clause = Clause::MakeEmptyClause();
  empty_clause->SetWeight(0);
  empty_clause->SetNumOfPosEq(0);
  empty_clause->SetMinResWeight(0);
  empty_clause->SetAncestors(ancestors.NewAncestors()); 
  return empty_clause;
 }; // Clause* RESOLVENT::MakeEmptyClause()


Clause* RESOLVENT::MakeUnitClause(TMP_LITERAL* lit)
 {

  DCONTROL8("BEGIN in RESOLVENT::MakeUnitClause(TMP_LITERAL* lit)");

  int_var_renaming.Reset();
  lit->RenameVariables(int_var_renaming);
  TERM* lit_list = TERM::NewLiterals(1,1);
  Clause* result = new Clause(lit_list);
  
  lit_list->Args()->SetFirst(lit->SharedCopy(result));
  
  result->SetAncestors(ancestors.NewAncestors()); 
  result->SetWeight(lit->Weight());
  if (lit->IsEquality() && lit->Positive()) { result->SetNumOfPosEq(1); }
  else result->SetNumOfPosEq(0); 
  if (lit->IsEquality() && lit->Positive())
   { result->SetMinResWeight(lit->PosEqMinLHSWeight()); }
  else result->SetMinResWeight(0);

  DCONTROL8("END in RESOLVENT::MakeUnitClause(TMP_LITERAL* lit)");

  return result;
 }; // Clause* RESOLVENT::MakeUnitClause(FLAT_TERM* lit)



Clause* RESOLVENT::MakeSharedClause(TMP_LIT_LIST& lits)
 {
  DCONTROL8("BEGIN in RESOLVENT::MakeSharedClause(..)");
  if (lits.Empty()) return MakeEmptyClause();
  long weight;
  long num_of_pos_eq;
  if (equality_possible)
   {
    lits.WeightAndNumOfPosEq(weight,num_of_pos_eq);
   }
  else
   { 
    weight = lits.Weight();
    num_of_pos_eq = 0;
   }; 
   
  TMP_LIT_LIST max_lits;
  TMP_LIT_LIST nonmax_lits; 
  TMP_LIT_LIST tmp_lits;
  TMP_LIT_LIST* ordered_max_lits;
  TMP_LIT_LIST* ordered_nonmax_lits; 


  //if (eliminate_predicates) cout << "BULLSHIT\n"; // debug

  if ((!eliminate_predicates) || (!lits.Eliminate(max_lits,nonmax_lits,eliminated_pred))) // experimental
   {
  
  if (equality_possible) { lits.KBOrder_NS_EQ(max_lits,nonmax_lits); }
  else   
   if (negative_selection) { lits.KBOrder_NS_NEQ(max_lits,nonmax_lits); }
   else lits.KBOrder_NEQ(max_lits,nonmax_lits);

   }; // experimental
  
  // don't use lits anymore! it must be empty here!
  
  int num_of_max = max_lits.Length();
  int num_of_nonmax = nonmax_lits.Length();

  //cout << "max " << num_of_max << "      nonmax " << num_of_nonmax << "\n"; // debug
  
  if (num_of_max > 1)
   {
    lits.CreateVarWeighting(var_weighting);
    max_lits.Order(tmp_lits,var_weighting);
    ordered_max_lits = &tmp_lits;
    if (num_of_nonmax > 1) 
     {
      max_lits.Reset();
      nonmax_lits.Order(max_lits,var_weighting);
      ordered_nonmax_lits = &max_lits; // this is not an error!
     }
    else ordered_nonmax_lits = &nonmax_lits;  
   }
  else
   {
    ordered_max_lits = &max_lits;
    if (num_of_nonmax > 1)
     {
      lits.CreateVarWeighting(var_weighting);
      nonmax_lits.Order(tmp_lits,var_weighting);
      ordered_nonmax_lits = &tmp_lits;
     }
    else ordered_nonmax_lits = &nonmax_lits;  
   };  
  
  int_var_renaming.Reset();
  // order of renaming is significant!
  ordered_max_lits->RenameVariables(int_var_renaming);
  ordered_nonmax_lits->RenameVariables(int_var_renaming);
  
  long weight_of_nonmax = ordered_nonmax_lits->MinFactorWeightUpperBound();
  
  long min_weight_of_max_pos_eq_lhs = 0;
  if (equality_possible)
   {
    min_weight_of_max_pos_eq_lhs = ordered_max_lits->MinPosEqLHSWeight();
   };
  
  TERM* lit_list = TERM::NewLiterals(num_of_max + num_of_nonmax,num_of_max);
  Clause* result = new Clause(lit_list);
  TERM* lit_ref = lit_list->Args();
  TERM* lit;
  TMP_LITERAL* tmp_lit;
  do
   {
    tmp_lit = ordered_max_lits->Pop();
    
    //cout << "TMP MAX LIT\n";
    //tmp_lit->Output();
    //cout << "\n";
    
    DCONTROL8("C50 in RESOLVENT::MakeSharedClause(..)");

    lit = tmp_lit->SharedCopy(result);
    
    DCONTROL8("C60 in RESOLVENT::MakeSharedClause(..)");

    //cout << "MAX LIT\n"; // debug
    //::Output(lit); // debug
    //cout << "\n"; // debug
    
    lit_ref->SetFirst(lit);
    lit_ref = lit_ref->Next();
    num_of_max--;
   }
  while (num_of_max); 
  
  while (num_of_nonmax)
   {
    DCONTROL8("C70 in RESOLVENT::MakeSharedClause(..)");
    lit = ordered_nonmax_lits->Pop()->SharedCopy(result);
    DCONTROL8("C80 in RESOLVENT::MakeSharedClause(..)");

    lit_ref->SetFirst(lit);
    lit_ref = lit_ref->Next();
    num_of_nonmax--;
   };
 
  DCONTROL8("C90 in RESOLVENT::MakeSharedClause(..)");  

  result->SetAncestors(ancestors.NewAncestors()); 
  result->SetWeight(weight);
  result->SetNumOfPosEq(num_of_pos_eq);
  result->SetMinResWeight(weight_of_nonmax + min_weight_of_max_pos_eq_lhs);
  
  DCONTROL8("END in RESOLVENT::MakeSharedClause(..)");
  
  return result; 
 }; // Clause* RESOLVENT::MakeSharedClause(TMP_LIT_LIST& lits)

Clause* RESOLVENT::MakeUnsharedClause(TMP_LIT_LIST& lits)
 {
  
  DCONTROL8("BEGIN in RESOLVENT::MakeUnsharedClause(..)");
 
  if (lits.Empty()) return MakeEmptyClause();
  long weight;
  long num_of_pos_eq;
  lits.WeightAndNumOfPosEq(weight,num_of_pos_eq);
     
  TMP_LIT_LIST max_lits;
  TMP_LIT_LIST nonmax_lits; 
  TMP_LIT_LIST tmp_lits;
  TMP_LIT_LIST* ordered_max_lits;
  TMP_LIT_LIST* ordered_nonmax_lits; 
  
  DCONTROL8("A2 in RESOLVENT::MakeUnsharedClause(..)");
  
  if (equality_possible) { lits.KBOrder_NS_EQ(max_lits,nonmax_lits); }
  else   
   if (negative_selection) { lits.KBOrder_NS_NEQ(max_lits,nonmax_lits); }
   else lits.KBOrder_NEQ(max_lits,nonmax_lits);
  
  DCONTROL8("A3 in RESOLVENT::MakeUnsharedClause(..)");
  
  // don't use lits anymore! it must be empty here!
  
  int num_of_max = max_lits.Length();
  int num_of_nonmax = nonmax_lits.Length();
  
  if (num_of_max > 1)
   {
    lits.CreateVarWeighting(var_weighting);
    max_lits.Order(tmp_lits,var_weighting);
    ordered_max_lits = &tmp_lits;
    if (num_of_nonmax > 1) 
     {
      max_lits.Reset();
      nonmax_lits.Order(max_lits,var_weighting);
      ordered_nonmax_lits = &max_lits; // this is not an error!
     }
    else ordered_nonmax_lits = &nonmax_lits;  
   }
  else
   {
    ordered_max_lits = &max_lits;
    if (num_of_nonmax > 1)
     {
      lits.CreateVarWeighting(var_weighting);
      nonmax_lits.Order(tmp_lits,var_weighting);
      ordered_nonmax_lits = &tmp_lits;
     }
    else ordered_nonmax_lits = &nonmax_lits;  
   };  
  
  DCONTROL8("A20 in RESOLVENT::MakeUnsharedClause(..)");

  int_var_renaming.Reset();
  // order of renaming is significant!
  ordered_max_lits->RenameVariables(int_var_renaming);
  ordered_nonmax_lits->RenameVariables(int_var_renaming);
  
  DCONTROL8("A30 in RESOLVENT::MakeUnsharedClause(..)");
  
  long weight_of_nonmax = ordered_nonmax_lits->MinFactorWeightUpperBound();
  
  long min_weight_of_max_pos_eq_lhs = 0;
  if (equality_possible)
   {
    min_weight_of_max_pos_eq_lhs = ordered_max_lits->MinPosEqLHSWeight();
   };
  
  TERM* lit_list = TERM::NewLiterals(num_of_max + num_of_nonmax,num_of_max);
  Clause* result = new Clause(lit_list);
  TERM* lit_ref = lit_list->Args();
  do
   {
    *lit_ref = ordered_max_lits->Pop()->StandardRepCopy();
    lit_ref = lit_ref->Next();
    num_of_max--;
   }
  while (num_of_max); 
  
  while (num_of_nonmax)
   {
    *lit_ref = ordered_nonmax_lits->Pop()->StandardRepCopy();
    lit_ref = lit_ref->Next();
    num_of_nonmax--;
   };
   
  result->SetAncestors(ancestors.NewAncestors()); 
  result->SetWeight(weight);
  result->SetNumOfPosEq(num_of_pos_eq);
  result->SetMinResWeight(weight_of_nonmax + min_weight_of_max_pos_eq_lhs);
  return result;
 }; // Clause* RESOLVENT::MakeUnsharedClause(TMP_LIT_LIST& lits)



Clause* RESOLVENT::MakeInputClause(TMP_LIT_LIST& lits)
 {
  DCONTROL8("BEGIN in RESOLVENT::MakeInputClause(TMP_LIT_LIST& lits)");
  if (lits.Empty()) return MakeEmptyClause();
  long weight;
  long num_of_pos_eq;
  lits.WeightAndNumOfPosEq(weight,num_of_pos_eq);
  
  int length = lits.Length();
  int_var_renaming.Reset();
  lits.RenameVariables(int_var_renaming);
  long weight_of_nonmax = 0;
  TERM* lit_list = TERM::NewLiterals(length,length);
  Clause* result = new Clause(lit_list);
  TERM* lit_ref = lit_list->Args();
  for (int i = 0; i < length; i++)
   {
    *lit_ref = lits.Pop()->StandardRepCopy();
    lit_ref = lit_ref->Next();
   };
  result->SetAncestors(ancestors.NewAncestors()); 
  result->SetWeight(weight);
  result->SetNumOfPosEq(num_of_pos_eq);
  result->SetMinResWeight(weight_of_nonmax); 
  DCONTROL8("END in RESOLVENT::MakeInputClause(TMP_LIT_LIST& lits)");
  return result;
 }; // Clause* RESOLVENT::MakeInputClause(TMP_LIT_LIST& lits)

Clause* RESOLVENT::MakeInputClause(ANCESTORS::BACKGR backgr)
 {
  DCONTROL8("BEGIN in RESOLVENT::MakeInputClause(ANCESTORS::BACKGR backgr)");
  SetBackground(backgr);
  DCONTROL8("A0 in RESOLVENT::MakeInputClause(ANCESTORS::BACKGR backgr)"); 
  clause.EndOfClause();
  DCONTROL8("A1 in RESOLVENT::MakeInputClause(ANCESTORS::BACKGR backgr)");
  return MakeInputClause(clause.AllLiterals());
 }; // Clause* RESOLVENT::MakeInputClause() 

bool RESOLVENT::PushLiteral(TERM* const t)
 {
  TERM header = *t;
  if (!(header.Arity())) 
   {
    return PushPropLit(header);
   };
  if (!(OpenNonpropLiteral(header))) return false;
  TERM::ITERATOR iter;
  iter.Reset(t);
  while (iter.Next()) 
   {
    if (iter.CurrentSymIsVar())
     {
      PushVar(iter.Symbol());
     }
    else
     {
      if (iter.Symbol().Arity())
       {
        if (!(PushNonconstFun(iter.Symbol()))) return false;
       }
      else PushConst(iter.Symbol()); 
     }; 
   };
  return CloseLiteral();
 }; // bool RESOLVENT::PushLiteral(TERM* const t)

bool RESOLVENT::LoadClause(const Clause* const c)
 {
   // cout << "LOAD\n    "; ::Output(c); cout << "\n";

  DCONTROL8("BEGIN in RESOLVENT::LoadClause(..)");
  Reset();
  TERM* lit = c->Literals()->Args();
  do
   {
    DCONTROL8("A5 in RESOLVENT::LoadClause(..)"); 
    if (!(PushLiteral(lit->First()))) { return false; };
    DCONTROL8("A6 in RESOLVENT::LoadClause(..)"); 
    lit = lit->Next();
    DCONTROL8("A7 in RESOLVENT::LoadClause(..)"); 
   }
  while (!(lit->IsNull()));
  DCONTROL8("A8 in RESOLVENT::LoadClause(..)"); 
  return true;
 }; // void RESOLVENT::LoadClause(Clause* const c)

bool RESOLVENT::PushRewrittenLit(PREFIX_SYM* lit,
                                 PREFIX_SYM* redex,
                                 TERM replacing_term,
                                 int index)
 {
  TERM header = lit->Head().Func();
  CHECK8(header.Arity(),"A1 in RESOLVENT::PushRewrittenLit(..)");
  if (header.IsEquality()) header.MakeUnordered(); 
  if (!(OpenNonpropLiteral(header))) return false;
  
  PREFIX::ITER iter;
  iter.Reset(lit);
  TERM sym;
  iter.SkipSym(); // skipping the header
  
  do
   {
    if (iter.CurrVar()) // free variable
     { 
      if (!(PushVar(var_renaming.Rename(iter.CurrVar())))) { return false; }; 
      iter.SkipSym(); 
     }
    else // functor
     {
      if (iter.CurrSubterm() == redex)
       {
        if (!PushStandardTerm(index,replacing_term)) return false;
        iter.SkipTerm();
       }
      else
       {
        sym = iter.CurrSubterm()->Head().Func();
        if (sym.Arity())
         {
          if (!(PushNonconstFun(sym))) return false;
         }
        else // constant
         PushConst(sym);
        iter.SkipSym();
       }; 
     };
   }
  while (!iter.Empty()); 
 
  return CloseLiteral();
 }; //  bool RESOLVENT::PushRewrittenLit(PREFIX_SYM* lit,...  


int RESOLVENT::ComponentName(TMP_LIT_LIST& component,bool& new_component)
 {
  TMP_LIT_LIST component_copy = component;
  component.Reset();

  component_copy.CreateVarWeighting(split_var_weighting);
  
  component_copy.Order(component,split_var_weighting);
  
  split_var_renaming.Reset();
  component.RenameVariables(split_var_renaming);
  
  return SplittingIndex.ComponentName(component,new_component);
 }; // int RESOLVENT::ComponentName(TMP_LIT_LIST& component,bool& new_component)





void RESOLVENT::StatSplitGroundComp(TMP_LIT_LIST& gr_comp,bool supported)
 {
  CHECK8(gr_comp.Length() > 0,"A0 in RESOLVENT::StatSplitGroundComp(TMP_LIT_LIST& gr_comp,bool supported)");    

  bool new_component;
  int comp_name;
  TMP_LIT_LIST small_gr_comp = gr_comp;
  gr_comp.Reset();
  small_gr_comp.Order(gr_comp,split_var_weighting);


  small_gr_comp.Reset();
  check_length:
   if (gr_comp.Length() > 3)
    {
     for (int i = 0; i <= 2; i++)
      {
       small_gr_comp.Push(gr_comp.Pop());
      };
    }
   else
    {
     small_gr_comp = gr_comp;
     gr_comp.Reset();
    }; 
   // process the small component 
   comp_name = ComponentName(small_gr_comp,new_component);
   if (new_component) 
    {
     TERM header((ARITY)0,(FUNCTOR)comp_name,POL_POS); // compatible with negative selection
     HeaderWeighting.MakeMinimal(header); 
           
     positive_name.Reset();
     positive_name.PushConst(header);
     small_gr_comp.Push(&positive_name);
     if (supported) 
      { 
       RegisterPreprocessedSupported(MakeUnsharedClause(small_gr_comp));
      }
     else
      {
       RegisterPreprocessedUnsupported(MakeUnsharedClause(small_gr_comp));
      }; 
    };
   TERM header((ARITY)0,(FUNCTOR)comp_name,POL_NEG); 
   HeaderWeighting.MakeMinimal(header); 
   basic_component.PushPropLit(header);
  if (gr_comp.Nonempty()) goto check_length; 
 }; // void RESOLVENT::StatSplitGroundComp(TMP_LIT_LIST& gr_comp,...                                


bool RESOLVENT::StaticSplitting(bool supported)
 {


  bool new_component;
  int comp_name;
  TMP_LIT_LIST literals(clause.AllLiterals());
  TMP_LIT_LIST ground_component;
  TMP_LIT_LIST nonground_component;
  
  // cout << "SPLIT \n";   
  //literals.Output(); cout << "\n"; // debug
  
  literals.CollectGround(ground_component);
  bool separate_ground_component;
  
  if (ground_component.Nonempty())
   {
    
    if ((literals.Length() > 1) || (ground_component.Length() > 4))
     {
     
      // splitting makes sense
      basic_component.Reset();
      separate_ground_component = (ground_component.Length() > 1);
      if (separate_ground_component)
       {
        
        StatSplitGroundComp(ground_component,supported); // experimental
        
        /*************
        comp_name = ComponentName(ground_component,new_component);
        if (new_component) 
         {
          TERM header((ARITY)0,(FUNCTOR)comp_name,POL_POS); // compatible with negative selection
          HeaderWeighting.MakeMinimal(header); 
          
          positive_name.Reset();
          positive_name.PushConst(header);
          ground_component.Push(&positive_name);
          if (supported) 
           { 
            RegisterPreprocessedSupported(MakeUnsharedClause(ground_component));
           }
          else
           {
            RegisterPreprocessedUnsupported(MakeUnsharedClause(ground_component));
           }; 
         };
        TERM header((ARITY)0,(FUNCTOR)comp_name,POL_NEG); 
        HeaderWeighting.MakeMinimal(header); 
        basic_component.PushPropLit(header); 
        **************/
       };
      
      // now process nonground literals
      next_nonground_component:
       if (literals.Empty()) goto collect_basic_component;
       literals.CollectNextComponent(nonground_component);
       comp_name = ComponentName(nonground_component,new_component); 
       if (new_component)
        {
         TERM header((ARITY)0,(FUNCTOR)comp_name,POL_POS); // compatible with negative selection
       
         HeaderWeighting.MakeMinimal(header); 
         
         positive_name.Reset();
         positive_name.PushConst(header);
         nonground_component.Push(&positive_name);
         if (supported) 
          { 
           RegisterPreprocessedSupported(MakeUnsharedClause(nonground_component));
          }
         else
          {
           RegisterPreprocessedUnsupported(MakeUnsharedClause(nonground_component));
          }; 
        };
       
       {
        TERM header((ARITY)0,(FUNCTOR)comp_name,POL_NEG); 
     
        HeaderWeighting.MakeMinimal(header); 

        basic_component.PushPropLit(header); 
       };
       
       if (literals.Nonempty()) goto next_nonground_component;
       
       // now process the basic component
       
       collect_basic_component: 
        basic_component.EndOfClause();
        if (!separate_ground_component)
         {
          basic_component.AllLiterals().Push(ground_component.Pop());
         };
        
       process_basic_component:
        if (supported) 
         { 
          RegisterPreprocessedSupported(MakeUnsharedClause(basic_component.AllLiterals()));
         }
        else
         {
          RegisterPreprocessedUnsupported(MakeUnsharedClause(basic_component.AllLiterals()));
         };
        return true;
     }
    else return false; // only ground literals
   };
  
  // only nonground literals 
  
  literals.CollectNextComponent(nonground_component);
  
  if (literals.Empty()) return false; // linked clause, no splitting 
  basic_component.Reset();
  process_current_nonground_component:
   comp_name = ComponentName(nonground_component,new_component);
   if (new_component)
    {
     TERM header((ARITY)0,(FUNCTOR)comp_name,POL_POS); // compatible with negative selection
   
     HeaderWeighting.MakeMinimal(header); 
          
     positive_name.Reset();
     positive_name.PushConst(header);
     nonground_component.Push(&positive_name);
     if (supported) 
      { 
       RegisterPreprocessedSupported(MakeUnsharedClause(nonground_component));
      }
     else
      {
       RegisterPreprocessedUnsupported(MakeUnsharedClause(nonground_component));
      }; 
    };
   TERM header((ARITY)0,(FUNCTOR)comp_name,POL_NEG); 

   HeaderWeighting.MakeMinimal(header); 

   basic_component.PushPropLit(header); 
  
   if (literals.Empty()) 
    {
     basic_component.EndOfClause();
     goto process_basic_component;
    }; 
   literals.CollectNextComponent(nonground_component);
   goto process_current_nonground_component;
 }; // bool RESOLVENT::StaticSplitting()


//******************************************************************
