#define __STATISTICS_H

class STATISTICS_ON_GENERATED
 {
  private:
   static long generated;
  
   static long tautology;
   static long forward_subsumed;
   static long simplified_resolvents;
   
   static long too_heavy_term;
   static long too_deep;
   static long too_heavy_clause;
   static long too_long_clause;
   static long too_many_variables;
   static long rejected_by_kept;
   static long purged_from_kept;
  public:
   static inline void Reset() 
    {
     generated = 0L;
     
     tautology = 0L;
     forward_subsumed = 0L;
     simplified_resolvents = 0L;
     
     too_heavy_term = 0L;
     too_deep = 0L;
     too_heavy_clause = 0L;
     too_long_clause = 0L;
     too_many_variables = 0L;
     rejected_by_kept = 0L;
     purged_from_kept = 0L;
    };
    
   static inline void AnotherGenerated() { generated++; };
   static inline long Generated() { return generated; };
   
   static inline void AnotherTautology() { tautology++; };
   static inline long Tautology() { return tautology; }; 
   
   static inline void AnotherForwardSubsumed() { forward_subsumed++; };
   static inline long ForwardSubsumed() { return forward_subsumed; };  
   static inline void AnotherSimplifiedResolvent() { simplified_resolvents++; };
   static inline long SimplifiedResolvents() { return simplified_resolvents; };  
    
   static inline void AnotherTooHeavyTerm() { too_heavy_term++; };
   static inline long TooHeavyTerm() { return too_heavy_term; };
   static inline void AnotherTooDeep() { too_deep++; };
   static inline long TooDeep() { return too_deep; };
   static inline void AnotherTooHeavyClause() { too_heavy_clause++; };
   static inline long TooHeavyClause() { return too_heavy_clause; };
   static inline void AnotherTooLongClause() { too_long_clause++; };
   static inline long TooLongClause() { return too_long_clause; };
   static inline void AnotherClauseWithTooManyVariables() { too_many_variables++; };
   static inline long TooManyVariables() { return too_many_variables; };
   static inline void AnotherRejectedByKept() { rejected_by_kept++; };
   static inline long RejectedByKept() { return rejected_by_kept; };
   static inline void AnotherPurgedFromKept() { purged_from_kept++; };
   static inline long PurgedFromKept() { return purged_from_kept; };
   
   static inline bool CompletenessViolated()
    {
     return (too_heavy_term 
             || too_deep 
             || too_heavy_clause
             || too_long_clause 
             || too_many_variables
             || rejected_by_kept
             || purged_from_kept);
    };
   static void Output();
 }; // class STATISTICS_ON_GENERATED





//*****************************************************************************