#include "subst.h"

//********** Methods of BINDINGS_WITH_OCCUR_CHECK: ********************************** 

bool BINDINGS_WITH_OCCUR_CHECK::Occurs(int var_ind,int var,
                                       int index,TERM* word)
 {
  // end of word must be set here! 
  TERM** bind;
  VarSet.Reset();
  links_to_check.Reset();
  TERM* end = *(WORD::End(word));
  if (var_ind == index)
   {
    while (word < end)
     {
      if (word->IsVariable())
       {
        if (word->Var() == var) { return true; };
        bind = Binding(index,word->Var()); 
        if ((*bind) && (!(VarSet.Member(index,word->Var())))) 
         // bound variable, was not memorized yet
         {
          VarSet.NewMember(index,word->Var());
          links_to_check.Push(bind);
         };
       };
      WORD::NextSym(word);       
     };
   }
  else // var_ind != index 
   {
    while (word < end)
     {
      if (word->IsVariable())
       {
        bind = Binding(index,word->Var()); 
        if ((*bind) && (!(VarSet.Member(index,word->Var())))) 
         // bound variable, was not memorized yet
         {
          VarSet.NewMember(index,word->Var());
          links_to_check.Push(bind);
         };
       };
      WORD::NextSym(word);       
     };
   };
   
  // upper level is checked, check postponed links

  try_next_link:
   if (links_to_check.Empty()) 
    {
     return false;
    } 
   else
    {
     bind = links_to_check.Pop();
     follow_link:
      word = *bind;
      index = Index(bind);
      if (word->IsVariable())
       {
        if ((var_ind == index) && (var == word->Var())) { return true; };
        bind = Binding(index,word->Var()); 
        if ((*bind) && (!(VarSet.Member(index,word->Var())))) 
         // bound variable, was not memorized yet
         {
          VarSet.NewMember(index,word->Var());
          goto follow_link;
         }
        else // free variable or already memorized
         {
          goto try_next_link;
         };
       }
      else // word represents a complex term
       {
        TERM* end = *(WORD::End(word));
        if (var_ind == index)
         {
          while (word < end)
           {
            if (word->IsVariable())
             {
              if (word->Var() == var) { return true; };
              bind = Binding(index,word->Var()); 
              if ((*bind) && (!(VarSet.Member(index,word->Var())))) 
              // bound variable, was not memorized yet
               {
                VarSet.NewMember(index,word->Var());
                links_to_check.Push(bind);
               };
             };
            WORD::NextSym(word);
           };
         }
        else // var_ind != index 
         {
          while (word < end)
           {
            if (word->IsVariable())
             {
              bind = Binding(index,word->Var()); 
              if ((*bind) && (!(VarSet.Member(index,word->Var())))) 
              // bound variable, was not memorized yet
               {
                VarSet.NewMember(index,word->Var());
                links_to_check.Push(bind);
               };
             };
            WORD::NextSym(word);
           };
         };
        goto try_next_link;
       };
    };
  
 }; // bool BINDINGS_WITH_OCCUR_CHECK::Occurs(int var_ind,int var,...
    
//*******************************************************************






















