#include "superposition.h" 
 
SUPERPOSITION Superposition;

//**************** Definitions for BACKWARD_SUPERPOSITION:  *************

void BACKWARD_SUPERPOSITION::Process(Clause* cl)
 {
  SetQuery(cl);
  bpara_premise.Load(cl);  
  for (const TERM* lit = bpara_premise.NextEq(); lit; lit = bpara_premise.NextEq())
   {
    bpara_machine.LoadEq(lit,bpara_premise.GetIndex());
    while (bpara_machine.Paramodulate())
     {
      //cout << "EQ "; ::Output(lit); cout << "\n"; // debug
      //cout << "CAND "; ::Output(bpara_machine.Candidate()->TheClause()); cout << "\n";
      if (CollectResult())
       {
        //cout << "B.SUPER INF.\n";
        //Resolvent.Output();
        //cout << "\n\n\n";
         
        Resolvent.ProcessCollected(); 
       };
     };
   };
 }; // void BACKWARD_SUPERPOSITION::Process(Clause* cl)

 
//**************** Definitions for EQ_FACTORING:  *************


void EQ_FACTORING::Process(Clause* cl)
 {
  if (!Load(cl)) return;   
     
  //cout << "LOADING "; ::Output(cl); cout << "\n";
  //cout << "SUBST:\n";
  //GlobalSubst.Output(OutputPrefix);
     
  while (NextInference())
   {
    //cout << "FACTOR "; ::Output(cl); cout << "\n\n";
    //eq_factor.Output(); cout << "\n\n"; // debug
       
    Resolvent.Reset();
    if (CollectResult())
     {       
      //cout << "COLLECTED\n"; Resolvent.Output(); cout << "\n\n\n";
         
      Resolvent.SetBackground(ANCESTORS::RESOL);
      Resolvent.PushAncestor(cl);
      Resolvent.ProcessCollected();
     };
   }; 
 }; // void EQ_FACTORING::Process(Clause* cl)



//*****************************************************************
