#define _NO_VOUT_

#include "vampire.h"
#include "term.h"
#ifndef __STACK_H
 #include "stack.h"
#endif

bool TERM::positive_is_greater = false; // default

void TERM::Destroy()
{
  TERMLIST* ts = Args();
  STACK<TERM*,MAX_TERM_DEPTH> stack("MAX_TERM_DEPTH");

  // not a constant
  for (;;)
    // this is very much based on the term's concrete representation
    switch (ts->Flag())
      {
      case TERM_COMPLEX:  // end of list
	delete ts;
	if (stack.Empty())  // no more subterms to inspect
	  return;
	// non-empty stack
	ts = stack.Pop();
	break;

      case TERM_REF:
	stack.Push(ts->First()->Args());
	// no break here!

      case TERM_VAR:  // variable
	ts = ts->Next();
	break;
      }  // switch
}  // TERM::Destroy()


//****************************************************************************
