#define __TIMER_H

#ifndef __VAMPIRE_H
#  include "vampire.h"	
#endif  

#include <time.h>

class TIMER
 {
  private:
   bool stopped;
   float elapsed_sec;
   clock_t start;
  public:
   inline void Reset() 
    {
     elapsed_sec = 0.0; 
     stopped = true;
    };
   TIMER() { Reset(); };
   inline void Start();
   inline void Stop();
   //inline void Recalculate();
   inline float Elapsed();
 }; // class TIMER
 
inline void TIMER::Start()
 {
  if (stopped)
   {
    stopped = false;
    start = clock();
   };
 };

inline void TIMER::Stop()
 {
  if (!(stopped))
   {
    stopped = true;
    elapsed_sec += (((float)(clock() - start))/CLOCKS_PER_SEC); 
   };
 };

inline float TIMER::Elapsed()
 {
  if (stopped)
   {
    return elapsed_sec;
   }
  else
   {
    clock_t tmp = clock();
    elapsed_sec += (((float)(tmp - start))/CLOCKS_PER_SEC);
    start = tmp;
    return elapsed_sec;    
   };
 };

//******************************************************************** 