#include <values.h>

#include <limits.h>

#define __VAMPIRE_H

#define VAMPIRE_VERSION "0.0"
#define VAMPIRE_DATE "1.07.1999"

  
// temporary      
#undef DOSX286
#define TIMER_CALIBRATE

//#undef _FAST_
#define _FAST_

// One of the following must be #defined, others #undefined

#ifdef __BCPLUSPLUS__
#  ifdef _Windows
#    define VAMPIRE_WINDOWS
#  else
#    define VAMPIRE_MSDOS
#  endif
#else  // not a PC
#  ifdef SUN_BSD  // Sun
#    define VAMPIRE_SUN
#  else
#    ifdef HP_UX
#      define VAMPIRE_HP
#    else
#      error Unsupported compilation platform
#    endif
#  endif
#endif


//#if sizeof(long) != 4 || sizeof(char*) != 4
//#  error This implementation uses that long and pointers occupy 4 bytes
//#endif


//#define _ALL_ENUM_VALUES_IN_SWITCHES_

//#define _SUPPRESS_WARNINGS_

void RuntimeError(const char* msg);
void RuntimeError(const char* msg1,const char* msg2,const char* msg3);

 
#ifdef _DEBUG_
 
void DebugError(const char* msg);

#endif

/*
	Global compilation constants. May be changed if needed
*/

const int MAX_NUMBER_OF_LITERALS = 31;  // !!!!!can't be greater than 31!!!!!
//const int MAX_FSTREE_BRANCHING = 256;
//const int MAX_FS_CODE_SIZE = 1024; // 512; 
const int MAX_NUMBER_OF_VARS = 64;
//const int MAX_NUMBER_OF_HYPER_VARS = 512;
//const int MAX_FORMULA_VARS = 128; 
const int MAX_TERM_DEPTH = 16; // 64; // 32;
const int MAX_TERM_WEIGHT = 128; // 64; //256; // 256;   

const int MAX_FINAL_PROOF_SIZE = 10000;
const int MAX_NAME_LENGTH = 250;

const int MAX_NUMBER_OF_TERM_ARGUMENTS = MAX_NUMBER_OF_LITERALS;
const int MAX_NUMBER_OF_32_BITS_STRUCTURES = 1024; 
  // can't be less than MAX_TERM_WEIGHT or MAX_NUMBER_OF_VARS     
         
const int MAX_CLAUSE_WEIGHT = MAX_TERM_WEIGHT * MAX_NUMBER_OF_LITERALS;
const int MAX_COMP_TERM_DEPTH = MAX_TERM_DEPTH * 8; // temporary value, potentially unsafe
const int MAX_TMP_TERM_WEIGHT = MAX_TERM_WEIGHT * 8; // potentially unsafe
const int MAX_NUMBER_OF_BS_INSTRUCTIONS = MAX_CLAUSE_WEIGHT + MAX_NUMBER_OF_LITERALS*2 + 1;
const int MAX_NUMBER_OF_FUNCTORS = 1024;
//const int MAX_NUMBER_OF_INPUT_PREDICATES = 1024;
const int MAX_NUMBER_OF_PREDICATES = MAX_NUMBER_OF_FUNCTORS;
const int MAX_NUMBER_OF_DIFFERENT_HEADERS = MAX_NUMBER_OF_FUNCTORS * 2;
const int MAX_NUMBER_OF_STANDARD_INDICES = MAX_NUMBER_OF_LITERALS + 1;
const int MAX_NUMBER_OF_INDICES = MAX_NUMBER_OF_STANDARD_INDICES + 2;
 // 2 extra indices for unit conflict in hyperresolution
const int MAX_NUMBER_OF_OPTIONS = 128;
const long MIN_MAX_WEIGHT = 1L;

const int EQ_NUM = 0;
const int ORD_EQ_NUM = 1;
const int FIRST_NONEQ_FUN = 2; 
 
inline bool IsEquality(int num) { return (num < FIRST_NONEQ_FUN); };
inline bool IsOrderedEq(int num) { return (bool)num; };
inline bool IsUnorderedEq(int num) { return !num; };

//  End of global compilation constants

#ifdef SUN_BSD
#  define EXIT_SUCCESS 0
#  define EXIT_FAILURE 1
#endif


#ifdef DOSX286
  // waiting for the new C++ standard...
  typedef int bool;
  #define true 1
  #define false 0
#endif 
